//TEST HC06 et autre
#define LEDRouge 8
#define LEDVerte 12
#include <SoftwareSerial.h>
#include <Adafruit_NeoPixel.h>
#include "Adafruit_NeoPixel.h"
#include <LiquidCrystal.h>
int NUM_LEDS = 35;
Adafruit_NeoPixel strip (NUM_LEDS, 6, NEO_GRB + NEO_KHZ800);
LiquidCrystal lcd(12, 11, 5, 4, 3, 2); //Liquid Crystallcd(12, 11, 5, 4, 3, 2);
SoftwareSerial HC06(11,10);
#define RXD 10;
#define TXD 11;
int coups1 = 0;
int coups2 = 0;
int player1 = 1;
int player2 = 3;
int scoreJoueur1 = 0;
int scoreJoueur2 = 0;
int whoseTurn;
int whoGoesFirst;
const int ROWS = 7;
const int COLUMNS = 35;
int gameBoard[ROWS][COLUMNS];
int r[6] = {255, 255, 0, 255, 0, 0}; // red, yellow, green, magenta, blue, orange
int g[6] = {0, 255, 255, 0, 0, 255};
int b[6] = {0, 0, 0, 255, 255, 0};

//LED
int colonne = 0;
int rowIndex = 5 - 1;
int NUM_ROWS = 5;
int NUM_COLS = 35;
int row;
int col;
int ledIndex = row * NUM_COLS + col;
int ledIndexNext = ledIndex + 7;

//ECRAN
/*#include "U8glib.h"

U8GLIB_ST7920_128X64_4X u8g(10);

void u8g_prepare(void) {
  u8g.setFont(u8g_font_6x10);
  u8g.setFontRefHeightExtendedText();
  u8g.setDefaultForegroundColor();
  u8g.setFontPosTop();
}

void u8g_ascii_1() {
  char s[2] = " ";
  uint8_t x, y;
  u8g.drawStr( 0, 0, "ASCII page 1");
  for( y = 0; y < 6; y++ ) {
    for( x = 0; x < 16; x++ ) {
      s[0] = y*16 + x + 32;
      u8g.drawStr(x*7, y*10+10, s);
    }
  }
}

void u8g_ascii_2() {
  char s[2] = " ";
  uint8_t x, y;
  u8g.drawStr( 0, 0, "ASCII page 2");
  for( y = 0; y < 6; y++ ) {
    for( x = 0; x < 16; x++ ) {
      s[0] = y*16 + x + 160;
      u8g.drawStr(x*7, y*10+10, s);
    }
  }
}

void u8g_extra_page(uint8_t a)
{
  if ( u8g.getMode() == U8G_MODE_HICOLOR || u8g.getMode() == U8G_MODE_R3G3B2) {*/
    /* draw background (area is 128x128) */
    //u8g_uint_t r, g, b;
   /* b = a << 5;
    for( g = 0; g < 64; g++ )
    {
      for( r = 0; r < 64; r++ )
      {
        u8g.setRGB(r<<2, g<<2, b );
        u8g.drawPixel(g, r);
      }
    }
    u8g.setRGB(255,255,255);
    u8g.drawStr( 66, 0, "Color Page");
  }
  else if ( u8g.getMode() == U8G_MODE_GRAY2BIT )
  {
    u8g.drawStr( 66, 0, "Gray Level");
    u8g.setColorIndex(1);
    u8g.drawBox(0, 4, 64, 32);    
    u8g.drawBox(70, 20, 4, 12);
    u8g.setColorIndex(2);
    u8g.drawBox(0+1*a, 4+1*a, 64-2*a, 32-2*a);
    u8g.drawBox(74, 20, 4, 12);
    u8g.setColorIndex(3);
    u8g.drawBox(0+2*a, 4+2*a, 64-4*a, 32-4*a);
    u8g.drawBox(78, 20, 4, 12);
  }
}

uint8_t draw_state = 0;
uint32_t player1_moves = 0;
uint32_t player2_moves = 0;

void draw(void) {
  u8g_prepare();
  switch(draw_state >> 3) {
    case 6: u8g_ascii_1(); break;
    case 7: u8g_ascii_2(); break;
  }

  // Afficher le nombre de coups joués par les joueurs
  char moves_str[20];
  snprintf(moves_str, sizeof(moves_str), "Joueur 1: %lu", coups1);
  u8g.drawStr(0, 50, moves_str);
  
  snprintf(moves_str, sizeof(moves_str), "Joueur 2: %lu",coups2);
  u8g.drawStr(0, 60, moves_str);
  
  uint32_t total_moves = coups1 + coups2;
  snprintf(moves_str, sizeof(moves_str), "Total: %lu", total_moves);
  u8g.drawStr(0, 70, moves_str);
}
*/
//Victoire
int Player1[]={};
int Player2[]={};

int NUM_LEDS_PER_COL =5;

void setup() {
  // put your setup code here, to run once:
randomSeed(analogRead(0));
pinMode(6,OUTPUT);
pinMode(LEDRouge, OUTPUT);
pinMode(LEDVerte, OUTPUT);
strip.begin(); strip.show(); strip.setBrightness(50); // maximum 255
randomSeed(analogRead(0)); // initialisation de la graine pour la fonction random
Serial.begin(9600); // initialisation de la communication série
HC06.begin(9600);
strip.begin();
initialise();
#if defined(ARDUINO)
  pinMode(13, OUTPUT);           
  digitalWrite(13, HIGH);  
#endif
}

void loop() {
  String voice;
   /* u8g.firstPage();  
  do {
    draw();
  } while( u8g.nextPage() );
  
  draw_state++;
  if ( draw_state >= 9*8 )
    draw_state = 0;
  
  player1_moves++;
  player2_moves++;
  
  // délai avant de mettre à jour l'affichage (facultatif)
  delay(1000);
*/
  while (HC06.available()){
    
    delay(10);
    char z = HC06.read();
    voice += z; // ajouter chaque caractère à la chaîne
    

    if (z == '#') {
      break;
    }
  }
  //Serial.println(voice); // afficher la chaîne complète
  
  twoPlayerGame(voice); // passer la chaîne complète à la fonction twoPlayerGame
}

  /*


  
void loop() {
  char c;
  String voice = "";
  
  // Lire les données envoyées par le module HC-06
  while (HC06.available()){
    delay(10);
    c = HC06.read();
    voice += c;
    Serial.print(c);
    
    // Appeler la fonction twoPlayerGame() avec la commande vocale reçue
    if (c == '#') {
      twoPlayerGame(voice);
      voice = "";
    }
  }
}

  */



//PLAYER 1 VOICE ************************************************************************************************************************************************************************************
void VocalRecognition1(String voice){
      digitalWrite(LEDRouge, HIGH);
      digitalWrite(LEDVerte, LOW);

    if (voice.length()>0){
     Serial.print(voice);
      if(voice == "colonne 1"){
        //
            if (strip.getPixelColor(0) != 0 && strip.getPixelColor(7)==0 && strip.getPixelColor(14)==0) {
              strip.setPixelColor(7, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} else if (strip.getPixelColor(7) != 0 && strip.getPixelColor(14)==0) {
              strip.setPixelColor(14, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(14) != 0 && strip.getPixelColor(21)==0) {
              strip.setPixelColor(21, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(21) != 0 && strip.getPixelColor(28)==0) {
              strip.setPixelColor(28, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else {
           strip.setPixelColor(0, strip.Color(0, 255, 0));
    strip.show();
    // La LED est éteinte
    // Faire quelque chose ici...
}

//
      Serial.println("J1 joue :");
      Serial.println(voice);
      //CheckLED(0,1);
      delay(50); 
      coups1 ++;
      delay(2000);
      digitalWrite(LEDRouge, LOW);
      digitalWrite(LEDVerte, HIGH);
  }

   else if(voice == "colonne de"){
 if (strip.getPixelColor(1) != 0 && strip.getPixelColor(8)==0 && strip.getPixelColor(15)==0) {
              strip.setPixelColor(8, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} else if (strip.getPixelColor(8) != 0 && strip.getPixelColor(15)==0) {
              strip.setPixelColor(15, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(15) != 0 && strip.getPixelColor(22)==0) {
              strip.setPixelColor(22, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(22) != 0 && strip.getPixelColor(29)==0) {
              strip.setPixelColor(29, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else {
           strip.setPixelColor(1, strip.Color(0, 255, 0));
    strip.show();
    // La LED est éteinte
    // Faire quelque chose ici...
}


      Serial.println("J1 joue :");
      Serial.println(voice);
     // CheckLED(1,1);
     delay(50);
     coups1 ++;
     delay(2000);
      digitalWrite(LEDRouge, LOW);
      digitalWrite(LEDVerte, HIGH);
  }

   else if(voice == "colonne 3"){

      if (strip.getPixelColor(2) != 0 && strip.getPixelColor(9)==0 && strip.getPixelColor(16)==0) {
              strip.setPixelColor(9, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} else if (strip.getPixelColor(9) != 0 && strip.getPixelColor(16)==0) {
              strip.setPixelColor(16, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(16) != 0 && strip.getPixelColor(23)==0) {
              strip.setPixelColor(23, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(23) != 0 && strip.getPixelColor(30)==0) {
              strip.setPixelColor(30, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else {
           strip.setPixelColor(2, strip.Color(0, 255, 0));
    strip.show();
    // La LED est éteinte
    // Faire quelque chose ici...
}

    Serial.println("J1 joue :");
      Serial.println(voice);
     //CheckLED(2,1);
     delay(50);
     coups1 ++;
     delay(2000);
     digitalWrite(LEDRouge, LOW);
      digitalWrite(LEDVerte, HIGH);
  }




   else if(voice == "colonne 4"){    
 if (strip.getPixelColor(3) != 0 && strip.getPixelColor(10)==0 && strip.getPixelColor(17)==0) {
              strip.setPixelColor(10, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} else if (strip.getPixelColor(10) != 0 && strip.getPixelColor(17)==0) {
              strip.setPixelColor(17, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(17) != 0 && strip.getPixelColor(24)==0) {
              strip.setPixelColor(24, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(24) != 0 && strip.getPixelColor(31)==0) {
              strip.setPixelColor(31, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else {
           strip.setPixelColor(3, strip.Color(3, 255, 0));
    strip.show();
    // La LED est éteinte
    // Faire quelque chose ici...
}

    
    Serial.println("J1 joue :");
      Serial.println(voice);
    // CheckLED(3,1);
     delay(50);
     coups1 ++;
     delay(2000);
     digitalWrite(LEDRouge, LOW);
      digitalWrite(LEDVerte, HIGH);
  }


   else if(voice == "colonne 5"){
     if (strip.getPixelColor(4) != 0 && strip.getPixelColor(11)==0 && strip.getPixelColor(18)==0) {
              strip.setPixelColor(11, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} else if (strip.getPixelColor(18) != 0 && strip.getPixelColor(14)==0) {
              strip.setPixelColor(18, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(18) != 0 && strip.getPixelColor(25)==0) {
              strip.setPixelColor(25, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(25) != 0 && strip.getPixelColor(32)==0) {
              strip.setPixelColor(32, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else {
           strip.setPixelColor(4, strip.Color(0, 255, 0));
    strip.show();
    // La LED est éteinte
    // Faire quelque chose ici...
}


    Serial.println("J1 joue :");
      Serial.println(voice);
    // CheckLED(4,1);
     delay(50);
     coups1 ++;
     delay(2000);
     digitalWrite(LEDRouge, LOW);
      digitalWrite(LEDVerte, HIGH);
  }

  else if(voice == "colonne 6"){
     if (strip.getPixelColor(5) != 0 && strip.getPixelColor(12)==0 && strip.getPixelColor(19)==0) {
              strip.setPixelColor(12, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} else if (strip.getPixelColor(12) != 0 && strip.getPixelColor(19)==0) {
              strip.setPixelColor(19, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(19) != 0 && strip.getPixelColor(26)==0) {
              strip.setPixelColor(26, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(26) != 0 && strip.getPixelColor(33)==0) {
              strip.setPixelColor(33, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else {
           strip.setPixelColor(5, strip.Color(0, 255, 0));
    strip.show();
    // La LED est éteinte
    // Faire quelque chose ici...
}


      Serial.println("J1 joue :");
      Serial.println(voice);
   //  CheckLED(5,1);
     delay(50);
     coups1 ++;
     delay(2000);
     digitalWrite(LEDRouge, LOW);
     digitalWrite(LEDVerte, HIGH);
  }
    else if(voice == "colonne 7"){

       if (strip.getPixelColor(6) != 0 && strip.getPixelColor(13)==0 && strip.getPixelColor(20)==0) {
              strip.setPixelColor(13, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} else if (strip.getPixelColor(13) != 0 && strip.getPixelColor(20)==0) {
              strip.setPixelColor(20, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(20) != 0 && strip.getPixelColor(27)==0) {
              strip.setPixelColor(27, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(27) != 0 && strip.getPixelColor(34)==0) {
              strip.setPixelColor(34, strip.Color(0, 255, 0));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else {
           strip.setPixelColor(6, strip.Color(0, 255, 0));
    strip.show();
    // La LED est éteinte
    // Faire quelque chose ici...
}

      Serial.println("J1 joue :");
      Serial.println(voice);
   //  CheckLED(5,1);
     delay(50);
     coups1 ++;
     delay(2000);
     digitalWrite(LEDRouge, LOW);
     digitalWrite(LEDVerte, HIGH);
  }
   else if(voice != "colonne 1" || voice !="colonne de" || voice !="colonne 3" || voice !="colonne 4"|| voice !="colonne 5" || voice !="colonne 6"|| voice !="colonne 7"){
          Serial.print("VEUILLEZ INDIQUER UNE COLONNE VALABLE");
            Serial.print("J1 :");
            Serial.print(voice);
  }
}

  }
//PLAYER 2 VOICE ************************************************************************************************************************************************************************************
void VocalRecognition2(String voice){
      digitalWrite(LEDRouge, LOW);
      digitalWrite(LEDVerte, HIGH);

      if(voice.length()>0){
      Serial.print(voice);

      if(voice == "colonne 1" ){
            if (strip.getPixelColor(0) != 0 && strip.getPixelColor(7)==0 && strip.getPixelColor(14)==0) {
              strip.setPixelColor(7, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} else if (strip.getPixelColor(7) != 0 && strip.getPixelColor(14)==0) {
              strip.setPixelColor(14, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(14) != 0 && strip.getPixelColor(21)==0) {
              strip.setPixelColor(21, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(21) != 0 && strip.getPixelColor(28)==0) {
              strip.setPixelColor(28, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else {
           strip.setPixelColor(0, strip.Color(0, 0, 255));
    strip.show();
    // La LED est éteinte
    // Faire quelque chose ici...
}
      Serial.println("J2 joue :");
     Serial.println(voice);
    //  CheckLED(0,2);
      delay(50);
      coups2 ++;
      delay(2000);
     digitalWrite(LEDRouge, HIGH);
     digitalWrite(LEDVerte, LOW);
  }

    else if(voice == "colonne de"){
if (strip.getPixelColor(1) != 0 && strip.getPixelColor(8)==0 && strip.getPixelColor(15)==0) {
              strip.setPixelColor(8, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} else if (strip.getPixelColor(8) != 0 && strip.getPixelColor(15)==0) {
              strip.setPixelColor(15, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(15) != 0 && strip.getPixelColor(22)==0) {
              strip.setPixelColor(22, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(22) != 0 && strip.getPixelColor(29)==0) {
              strip.setPixelColor(29, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else {
           strip.setPixelColor(1, strip.Color(0, 0, 255));
    strip.show();
    // La LED est éteinte
    // Faire quelque chose ici...
}

      Serial.println("J2 joue :");
      Serial.println(voice);
    //  CheckLED(1,2);
      delay(50);
     coups2 ++;
     delay(2000);
     digitalWrite(LEDRouge, HIGH);
     digitalWrite(LEDVerte, LOW);
  }

   else if(voice == "colonne 3"){

      if (strip.getPixelColor(2) != 0 && strip.getPixelColor(9)==0 && strip.getPixelColor(16)==0) {
              strip.setPixelColor(9, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} else if (strip.getPixelColor(9) != 0 && strip.getPixelColor(16)==0) {
              strip.setPixelColor(16, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(16) != 0 && strip.getPixelColor(23)==0) {
              strip.setPixelColor(23, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(23) != 0 && strip.getPixelColor(30)==0) {
              strip.setPixelColor(30, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else {
           strip.setPixelColor(2, strip.Color(0, 0, 255));
    strip.show();
    // La LED est éteinte
    // Faire quelque chose ici...
}

     Serial.println("J2 joue :");
      Serial.println(voice);
    //  CheckLED(2,2);
      delay(50);
     coups2 ++;
     delay(2000);
     digitalWrite(LEDRouge, HIGH);
     digitalWrite(LEDVerte, LOW);
  }

   else if(voice == "colonne 4"){ 
     if (strip.getPixelColor(3) != 0 && strip.getPixelColor(10)==0 && strip.getPixelColor(17)==0) {
              strip.setPixelColor(10, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} else if (strip.getPixelColor(10) != 0 && strip.getPixelColor(17)==0) {
              strip.setPixelColor(17, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(17) != 0 && strip.getPixelColor(24)==0) {
              strip.setPixelColor(24, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(24) != 0 && strip.getPixelColor(31)==0) {
              strip.setPixelColor(31, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else {
           strip.setPixelColor(3, strip.Color(0, 0, 255));
    strip.show();
    // La LED est éteinte
    // Faire quelque chose ici...
}
        Serial.println("J2 joue :");
      Serial.println(voice);
   //  CheckLED(3,2);
     delay(50);
     coups2 ++;
     delay(2000);
      digitalWrite(LEDRouge, HIGH);
     digitalWrite(LEDVerte, LOW);
  }
   else if(voice == "colonne 5"){     
     if (strip.getPixelColor(4) != 0 && strip.getPixelColor(11)==0 && strip.getPixelColor(18)==0) {
              strip.setPixelColor(11, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} else if (strip.getPixelColor(18) != 0 && strip.getPixelColor(14)==0) {
              strip.setPixelColor(18, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(18) != 0 && strip.getPixelColor(25)==0) {
              strip.setPixelColor(25, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(25) != 0 && strip.getPixelColor(32)==0) {
              strip.setPixelColor(32, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else {
           strip.setPixelColor(4, strip.Color(0, 0, 255));
    strip.show();
    // La LED est éteinte
    // Faire quelque chose ici...
}
        Serial.println("J2 joue :");
      Serial.println(voice);
   //  CheckLED(4,2);
     delay(50);
     coups2 ++;
     delay(2000);
     digitalWrite(LEDRouge, HIGH);
     digitalWrite(LEDVerte, LOW);
  }

   else if(voice == "colonne 6"){
     if (strip.getPixelColor(5) != 0 && strip.getPixelColor(12)==0 && strip.getPixelColor(19)==0) {
              strip.setPixelColor(12, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} else if (strip.getPixelColor(12) != 0 && strip.getPixelColor(19)==0) {
              strip.setPixelColor(19, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(19) != 0 && strip.getPixelColor(26)==0) {
              strip.setPixelColor(26, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(26) != 0 && strip.getPixelColor(33)==0) {
              strip.setPixelColor(33, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} else {
               strip.setPixelColor(5, strip.Color(0, 0, 255));
              strip.show();

}
        Serial.println("J2 joue :");
      Serial.println(voice);
   //  CheckLED(5,2);
     delay(50);
     coups2 ++;
     delay(2000);
        digitalWrite(LEDRouge, HIGH);
     digitalWrite(LEDVerte, LOW);
  }
   else if(voice == "colonne 7"){
     
     if (strip.getPixelColor(6) != 0 && strip.getPixelColor(13)==0 && strip.getPixelColor(20)==0) {
              strip.setPixelColor(13, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} else if (strip.getPixelColor(13) != 0 && strip.getPixelColor(20)==0) {
              strip.setPixelColor(20, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(20) != 0 && strip.getPixelColor(27)==0) {
              strip.setPixelColor(27, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else if (strip.getPixelColor(27) != 0 && strip.getPixelColor(34)==0) {
              strip.setPixelColor(34, strip.Color(0, 0, 255));
              strip.show();
            
    // La LED est allumée
    // Faire quelque chose ici...
} 
else {
           strip.setPixelColor(6, strip.Color(0, 0, 255));
    strip.show();
    // La LED est éteinte
    // Faire quelque chose ici...
}
        Serial.println("J2 joue :");
      Serial.println(voice);
   //  CheckLED(5,2);
     delay(50);
     coups2 ++;
     delay(2000);
        digitalWrite(LEDRouge, HIGH);
     digitalWrite(LEDVerte, LOW);
  }
    else if(voice != "colonne 1" || voice !="colonne de" || voice !="colonne 3" || voice !="colonne 4"|| voice !="colonne 5" || voice !="colonne 6"|| voice !="colonne 7"){
          Serial.print("VEUILLEZ INDIQUER UNE COLONNE");
            Serial.print("J2 :");
            Serial.print(voice);
  }
      }
  }
//INITIALISATION FUNCTION**************************************************************************************************************************************************************************
void initialise(){
    int whoGoesFirst = random(2); // renvoie un nombre aléatoire entre 0 et 1
    if (whoGoesFirst == 0) {
      whoseTurn = 1;
    } else {
      whoseTurn = 2;
    }
        Serial.print("whoGoesFirst: ");
    Serial.print(whoGoesFirst );
    Serial.print(" whoseTurn: ");
    Serial.println(whoseTurn);
}
//PICK RANDOM PLAYER FUNCTION************************************************************************************************************************************************************************************

void twoPlayerGame (String voice) {

  while (voice.length() > 0) {
    Serial.println("TWOPLAYERGAME ACTIVATED");
    //pickRandomPlayer();
    //fillBoard(); //for testing
      if (whoseTurn == 1) {
        Serial.println("JOUEUR 1 QUI A JOUE");
        endGame(1);
   
      //ScoreScreen(player1, player2, whoseTurn);
      //delay(60000);
      //resetScoreScreen();
       //ScoreScreen(player1, player2, whoseTurn);
        VocalRecognition1(voice);
        whoseTurn = 2;
        Serial.print("qui joue la prochaine fois : ");
        Serial.println(whoseTurn);
        break;
      } 

      else if (whoseTurn == 2) {
        Serial.println("JOUEUR 2 QUI A JOUE");
        endGame(2);
     
      //ScoreScreen(player1, player2, whoseTurn);
      //delay(60000);
      //resetScoreScreen();
        //ScoreScreen(player1, player2, whoseTurn);
        VocalRecognition2(voice);
        whoseTurn = 1;
        Serial.print("qui joue la prochaine fois : ");
        Serial.println(whoseTurn);
        break;
        }
    

    melt();
    if (voice == "#") {
      break;
    }
  }
}


/*void pickRandomPlayer(){
int x = random(player1, player2);
if(x>= 1,5){
  x=2;
}if(x< 1,5) {
  x=1;
  }
else {
     Serial.print("ERROR"); 
}
whoseTurn = x;

}*/
//2 PLAYERS GAME************************************************************************************************************************************************************************************
 /* void twoPlayerGame (String voice) {
    while(voice.length()>0){
    Serial.print("TWOPLAYERGAME ACTIVATED");
    //pickRandomPlayer();

int x = random(player1, player2);
x = whoGoesFirst;
if(x>= 1,5){
  x=2;
  whoseTurn=2;
}if(x< 1.5) {
  x=1;
  whoseTurn = 1;
  }
else {
     Serial.print("ERROR"); 
}

    Serial.print(x);
    Serial.print(whoseTurn);

  //fillBoard(); //for testing


  //while (eachTurn(whoseTurn) == 0) {  //returns 1 if end of game.. TODO recode this
 if(endGame(whoseTurn)){
       Serial.print("JEU FINI");
    ScoreScreen(player1,player2,x);
    delay (60000);
    resetScoreScreen();
  }
  if (!endGame(whoseTurn)){//SUSPECTED TO LOOP
    if (whoseTurn == 1) {
      Serial.print("JOUEUR 1 QUI A JOUE");
      ScoreScreen(player1, player2,whoseTurn);
      VocalRecognition1(voice);
      int player = whoseTurn;
      whoseTurn=2;
      Serial.print("qui joue la prochaine fois : ");
      Serial.print(whoseTurn);
        //  Serial.print(whoseTurn);
    } 
    
    else if (whoseTurn==2 ){//SUSPECTED TO LOOP
      Serial.print("JOUEUR 2 QUI A JOUE");
      ScoreScreen(player1, player2,whoseTurn);
      VocalRecognition2(voice);
      int player = whoseTurn;
      whoseTurn=1;
      Serial.print("qui joue la prochaine fois : ");
      Serial.print(whoseTurn);
        //  Serial.print(whoseTurn);
    }
  }


  melt();
   if(voice='#'){break;}
    }
}
*/
//***********************************************************************FONCTIONS**********************************************************************************

//RUNNING GAME DEMO************************************************************************************************************************
//void runDemo () {
//  randomPlay(50); //play 50 turns or until game over
//  delay(1000); //pause before "melt" the screen
//  melt();
//  delay(500); //pause after "melt"
//}

//ECRAN SCORE************************************************************************************************************************************************************************************
/*void ScoreScreen(int player1,int player2, int whoseTurn) {
  Serial.println("ScoreScreen");
  // Afficher les scores
  if(whoseTurn == player1 && (!endGame(player2)||!endGame(player1))){
      Serial.println("ScoreScreen J1");
  lcd.setCursor(0, 1);
  lcd.print(scoreJoueur1);
    lcd.print(coups1);
  }
  if(whoseTurn == player2 && (!endGame(player2)||!endGame(player1)) ){
       Serial.println("ScoreScreen J2");
      lcd.setCursor(0, 1);
      lcd.print(scoreJoueur2);
      lcd.print(coups2);
  }
  if(endGame(player1)|| endGame(player2)){
      Serial.println("ScoreScreen J1 et J2");
  lcd.setCursor(0, 1);
  lcd.print(scoreJoueur1);
  lcd.setCursor(10, 1);
  lcd.print(scoreJoueur2);
  lcd.print(coups1 + coups2);
}
  // Attendre 1 seconde avant de mettre à jour les scores à nouveau
  delay(1000);
}

void resetScoreScreen(){
  int coups1=0;
  int coups2=0;
  int scoreJoueur1=0;
  int scoreJoueur2=0;
  lcd.setCursor(0, 1);
  lcd.print(scoreJoueur1);
  lcd.setCursor(10, 1);
  lcd.print(scoreJoueur2);
  lcd.print(coups1 + coups2);
}
*/


//VERIFICATION LED************************************************************************************************************************

// Fonction de vérification des LED
/*void CheckLED(int column,int player) {
  int Column_L = column +1;
  Serial.println("CHECKLED");
   Serial.println(Column_L);
    Serial.println(player);
   // Trouver l'indice de la LED tout en bas de la colonne donnée
  int bottom_led_index = Column_L * NUM_LEDS_PER_COL + NUM_LEDS_PER_COL - 1;

  // Parcourir la colonne de bas en haut pour trouver la première LED allumée
  for (int i = bottom_led_index; i >= Column_L; i -= NUM_COLS) {
        Serial.println(bottom_led_index);
    if (strip.getPixelColor(i) != 0) {  // LED allumée trouvée
    Serial.println(i);
      // Allumer la LED au-dessus de la LED allumée la plus basse
      int index_above = i - NUM_COLS;
      if (index_above >= Column_L) {  // Vérifier que la LED à allumer est dans la colonne donnée
        strip.setPixelColor(index_above, (player == 1) ? strip.Color(0, 0, 255) : strip.Color(0, 255, 0)); // Allumer la LED en bleu pour le joueur 1, en vert pour le joueur 2
        strip.show();
        
      }
    } else if (i == Column_L) {  // Aucune LED allumée dans la colonne donnée
      // Allumer la LED tout en bas de la colonne
      strip.setPixelColor(bottom_led_index, (player == 1) ? strip.Color(0, 0, 255) : strip.Color(0, 255, 0)); // Allumer la LED en bleu pour le joueur 1, en vert pour le joueur 2
      strip.show();
    }
     
  }
  Serial.println("FIN LED");
}
*/

//TEST WINNING************************************************************************************************************************

void endGame(int joueur) {
  // Définir la couleur en fonction du joueur
  uint32_t couleur1;
  uint32_t couleur2;
  if (joueur == 1) {
    couleur1 = strip.Color(0, 255, 0); // Vert
     // Vérifier les alignements horizontaux
    for (int i = 0; i < NUM_LEDS - 3; i++) {
    if (strip.getPixelColor(i) == couleur1 &&
        strip.getPixelColor(i + 1) == couleur1 &&
        strip.getPixelColor(i + 2) == couleur1 &&
        strip.getPixelColor(i + 3) == couleur1) {
          Serial.println("Victoire Horizontale");
      // Victoire trouvée
      Serial.println("Victoire Horizontale");
       Serial.println("JEU FINI");
      return true;
    }
  }

  // Vérifier les alignements verticaux
  for (int i = 0; i < NUM_LEDS; i++) {
    if (strip.getPixelColor(i) == couleur1 &&
        strip.getPixelColor(i + 7) == couleur1 &&
        strip.getPixelColor(i + 14) == couleur1 &&
        strip.getPixelColor(i + 21) == couleur1) {
      // Victoire trouvée
                Serial.println("Victoire Verticale");
                 Serial.println("JEU FINI");
      return true;
    }
  }

  // Vérifier les alignements en diagonale descendante
  for (int i = 0; i < NUM_LEDS - 24; i++) {
    if (strip.getPixelColor(i) == couleur1 &&
        strip.getPixelColor(i + 8) == couleur1 &&
        strip.getPixelColor(i + 16) == couleur1 &&
        strip.getPixelColor(i + 24) == couleur1) {
                    Serial.println("Diagonale descendante");
                     Serial.println("JEU FINI");
      // Victoire trouvée
      return true;
    }
  }

  // Vérifier les alignements en diagonale ascendante
  for (int i = 18; i < NUM_LEDS; i++) {
    if (strip.getPixelColor(i) == couleur1 &&
        strip.getPixelColor(i - 6) == couleur1 &&
        strip.getPixelColor(i - 12) == couleur1 &&
        strip.getPixelColor(i - 18) == couleur1) {
                    Serial.println("Diagonale ascendante");
                     Serial.println("JEU FINI");
      // Victoire trouvée
      return true;
      }
    }

    // Aucune victoire trouvée
    return false;
    Serial.println(couleur1);
  } 
  
  
  else if (joueur == 2) {
    couleur2 = strip.Color(0, 0, 255); // Bleu
     // Vérifier les alignements horizontaux
  for (int i = 0; i < NUM_LEDS - 3; i++) {
    Serial.println("Verif Hori");
    if (strip.getPixelColor(i) == couleur2 &&
        strip.getPixelColor(i + 1) == couleur2 &&
        strip.getPixelColor(i + 2) == couleur2 &&
        strip.getPixelColor(i + 3) == couleur2) {
          Serial.println("Victoire Horizontale");
      // Victoire trouvée
      Serial.println("Victoire Horizontale");
       Serial.println("JEU FINI");
      return true;
    }
  }

  // Vérifier les alignements verticaux
  for (int i = 0; i < 7; i++) {
    Serial.println("Verif Verti");
    if (strip.getPixelColor(i) == couleur2 &&
        strip.getPixelColor(i + 7) == couleur2 &&
        strip.getPixelColor(i + 14) == couleur2 &&
        strip.getPixelColor(i + 21) == couleur2) {
      // Victoire trouvée
                Serial.println("Victoire Verticale");
                 Serial.println("JEU FINI");
      return true;
    }
  }

  // Vérifier les alignements en diagonale descendante
  for (int i = 0; i < NUM_LEDS - 24; i++) {
    Serial.println("Verif Diago desc");
    if (strip.getPixelColor(i) == couleur2 &&
        strip.getPixelColor(i + 8) == couleur2 &&
        strip.getPixelColor(i + 16) == couleur2 &&
        strip.getPixelColor(i + 24) == couleur2) {
                    Serial.println("Diagonale descendante");
                     Serial.println("JEU FINI");
      // Victoire trouvée
      return true;
    }
  }

  // Vérifier les alignements en diagonale ascendante
  for (int i = 18; i < NUM_LEDS; i++) {
    Serial.println("Verif Diago asc");
    if (strip.getPixelColor(i) == couleur2 &&
        strip.getPixelColor(i - 6) == couleur2 &&
        strip.getPixelColor(i - 12) == couleur2 &&
        strip.getPixelColor(i - 18) == couleur2) {
                    Serial.println("Diagonale ascendante");
                     Serial.println("JEU FINI");
      // Victoire trouvée
      return true;
    }
  }

  // Aucune victoire trouvée
  return false;
    Serial.println(couleur2);
  } else {
    // Numéro de joueur invalide
    return false;
  }

 
}

//MELT LOOP************************************************************************************************************************

void melt() { //melting effect
  int board[64];

// initialize board with zeros
for (int i = 0; i < 64; i++) {
  board[i] = 0;
}

  int color;

  //Serial.println("initiate melting effect");

  for (int k = 0; k <= 7; k++) {
    //first time 55 to

    for (int i = 55; i >= 8 * k; i--) { //64-9=55 always starts from the 2nd to the bottom row

      int board[64];

          // initialize board with zeros
          

      color = board[i];

      //change row below to the same color as top
      if (color == 0) {
        strip.setPixelColor(i + 8, strip.Color(0, 0, 0)); // black
        board[i + 8] = 0;
      } else {
        strip.setPixelColor(i + 8, strip.Color(r[color - 1], g[color - 1], b[color - 1])); // set color
        board[i + 8] = color;
      }

    }

    strip.show();
    delay(80);

    //change top rows to black //h = 0, from 7 to 0, h=1, from 15 to 8, when h=2, 23-16
    for (int i = (7 + (8 * k)); i >= (8 * k); i--) {
      strip.setPixelColor(i, strip.Color(0, 0, 0)); // black
      board[i] = 0;
    }
    //Serial.println("outloop");

    strip.show();
    //drawBoard();
    //delay(50);
  }

  delay(500);
}
